local function Path(_first)
    local self = {}
    local first,tail = _first, nil
    local totalLength = 0
    
    if first~=nil then
        tail = first
        totalLength = first.length
        while tail.next~=nil do
            tail = tail.next
            totalLength = totalLength + tail.length
        end
    end
    
    self.addElement = function(start,dir,length)
        if first==nil then
            first = {start=start, dir=dir, length=length, next=nil}
            tail = first
        elseif util.distance(start, util.moveposition(tail.pos, tail.dir, tail.length-1)) then
            error("Disjunct path elements")
        else
            tail.next = {start=start, dir=dir, length=length, next=nil}
            tail = tail.next
        end
        totalLength = totalLength + length
    end
    
    self.build = function()
        local tmp = first
        while tmp~=nil do
            local deltaX, deltaY = getDeltaXY({width=1,height=1}, tab.lineDir)
            for i=0, tmp.length-1 do
                map.addPipe({x=tmp.pos.x+i*deltaX,y=tmp.pos.y+i*deltaY})
            end
        
            builder.buildLine {entity="pipe", count=tmp.length, pos=tmp.start, lineDir=tmp.dir}
            tmp = tmp.next
        end
    end
    
    self.getTotalLength = function()
        return totalLength
    end
    
    self.getLastPosition = function()
        return util.moveposition(tail.pos, tail.dir, tail.length-1)
    end
    
    self.clone = function()
        return Path(table.deepcopy(first))
    end
    return self
end